      SUBROUTINE soa_dyn(cbox,ctotaerbox,maerbox)

      USE flags_module,ONLY: dyn_fg,wall_fg
      USE io_units_module,ONLY: lout
      USE time_mgmt_module
      USE NetCDF_vars_module,ONLY: ncid_prev,ncid_out
      USE akparameter_module
      USE solver_params_module,ONLY: dtmin,dtmax,numit
      USE forcing_params_module
      USE module_data_gecko_main

      IMPLICIT NONE

      REAL    :: maerbox       ! = maer(ibox)
      REAL    :: ctotaerbox    ! = ctotaer(ibox)
      REAL,DIMENSION(maxsp):: cbox  ! = conc(1:numsp,ibox)

! -------------------------------------
      !PRINT*,"starting dynamic soa"

      IF (dyn_fg.EQ.0) THEN
        ratfac=6.E-3  ! simple multiplicative factor gas-> aero rate
        CALL mtrat_ba(ratfac,winfac,weqfac, &
                       numain,numaou,numwin,numwou, &
                       idain,idaou,idwin,idwou,aoucf,woucf, &
                       temp,ctotaerbox, &
                       qfor, wall_fg)

        ELSE IF (dyn_fg.EQ.1) THEN
          imtr=0      ! 0 mt approach, 1 diff, 2 coll
          ratfac=1.   ! simple multiplicative factor gas-> aero rate
          CALL mtrat(ratfac,winfac,weqfac, &
                     numain,numaou,numwin,numwou, &
                     idain,idaou,idwin,idwou, &
                     !aoucf,woucf,wincf, &
                     !woucf,wincf, temp, &
                     temp,ctotaerbox,cnv,sumc(nbox), &
                     gamm,Mp,Rpo,maerbox,psat, &
                     wmol,imtr,idrestoi, &
                     Rp,qfor)
        ENDIF

      !PRINT*,"after dynamic soa"

! -------------------------------------
      END SUBROUTINE soa_dyn
! -------------------------------------

